import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;


/**
 * Write a description of class Player here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Player extends SmoothMover
{
    /**
     * Act - do whatever the Player wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    
    private static final double DIAMETER = 54.0;
    private static final int RADIUS = 27;
    
    private boolean out;
    private boolean haveHitLastAct;
    
    private boolean moving;
    double xVel = 0;
    double yVel = 0;
    Vector v;
    String ups;
    String downs;
    String rights;
    String lefts;
    public Player(String right,String down,String left,String up){
        ups = up;
        downs = down;
        lefts = left;
        rights = right;
    }    
    public void act() 
    {

        if(Greenfoot.isKeyDown(ups)){
            yVel -= 0.2;
        }else if(Greenfoot.isKeyDown(downs)){
            yVel += 0.2;
        }
        if(Greenfoot.isKeyDown(lefts)){
            xVel -= 0.2;
        }else if(Greenfoot.isKeyDown(rights)){
            xVel += 0.2;
        }
        
        //setLocation(getExactX()+xVel,getExactY()+yVel);
        Vector v = new Vector(xVel,yVel);
        addForce(v);
        movement.scale(0.98);
        move();
        xVel = yVel = 0;
        berührung();
        remove();
        
        if (out) {
            move();
        }
        else if (moving) {
            move();
            berührung();
            if (getSpeed() < 0.1) {
                setMoving(false);
            }
        }
    }
    public void remove()
    {
        World world = getWorld();
        if(getX() >= getWorld().getWidth() -27)
        world.removeObject(this);
        else if(getX() <= 27)
        world.removeObject(this);
        else if(getY() >= getWorld().getHeight() -27)
        world.removeObject(this);
        else if(getY() <= 27)
        world.removeObject(this);
        
        if(xVel > 5){
            xVel = 5;
        }else if(xVel < -5){
            xVel = -5;
        }
        if(yVel > 5){
            yVel = 5;
        }else if(yVel < -5){
            yVel = -5;
        }
    }
    public void berührung(){
        List<Player> players = (List<Player>) getIntersectingObjects(Player.class);
        for (Player player : players) {
            // schaut, welche von diesen sich wirklich mit der Murmel überschneiden (das Bild ist
            // größer als die Murmel, so dass wir den Schatten zeichnen können etc.).
            if ( haveHit(player) ) {
                doCollision(player);
            }
        }
    }
    private void doCollision(Player player)
    {
        double dx = this.getExactX() - player.getExactX();
        double dy = this.getExactY() - player.getExactY();
        int direction = (int) Math.toDegrees(Math.atan2(dy, dx));
        double angle = direction - getMovement().getDirection();
        
        // wenn der Winkel nicht zwischen 90 und 270 liegt, dann wurden wir von hinten getroffen und die andere Kugel wird nicht bewegt
        if (Math.abs(angle) < 90 || Math.abs(angle) > 270) {
            return;
        }
        double length = Math.cos(Math.toRadians(angle)) * getMovement().getLength();
        player.addForce( new Vector (direction, length) );
        //player.setMoving(true);
        
        this.addForce (new Vector (direction + 180, length) );
        //System.out.println("dir (after): " + direction + "  " + this);
    }
    private boolean haveHit(Player player)
    {
        int dx = Math.abs (this.getX() - player.getX());
        int dy = Math.abs (this.getY() - player.getY());
        double distance = Math.sqrt(dx*dx+dy*dy);
        
        return distance < DIAMETER;
    }
    public void setMoving(boolean move)
    {
        moving = move;
    }
    public void win(){
        if(getWorld().numberOfObjects() == 1){
            GreenfootImage image = new GreenfootImage(100, 20);  
            image.drawString("Gewinner!!!", getX(), getY());  
            Greenfoot.stop();
        }else{}
    }
}
